From b269c1b493f017231cf958aaf3331a7870096f89 Mon Sep 17 00:00:00 2001
From: Kalle Valo <kvalo@codeaurora.org>
Date: Tue, 10 May 2016 16:34:42 +0300
Subject: [PATCH 09/14] pwcli: cmd_commit(): improve "accept" choises in the
 end

Signed-off-by: Kalle Valo <kvalo@codeaurora.org>
---

Copyright (c) 2016, The Linux Foundation.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

3. Neither the name of the copyright holder nor the names of its
contributors may be used to endorse or promote products derived from
this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 cmdtests/list.script |    4 +--
 cmdtests/list.stdout |    6 ++--
 pwcli                |   74 ++++++++++++++++++++++++++++++++++++++++----------
 3 files changed, 65 insertions(+), 19 deletions(-)

diff --git a/cmdtests/list.script b/cmdtests/list.script
index d3f174231257..e07b99d78cc6 100755
--- a/cmdtests/list.script
+++ b/cmdtests/list.script
@@ -39,8 +39,8 @@ def main():
    child.sendline('commit 1')
    child.expect('commit All/commit Individually/aBort\?')
    child.sendline('a')
-   child.expect('Update state in patchwork\? \[y/N\]')
-   child.sendline('y')
+   child.expect('Accept/request Changes/Reject/Show mail/Edit mail/aBort?')
+   child.sendline('a')
    child.expect('Send/Edit/Abort\?')
    child.sendline('s')
 
diff --git a/cmdtests/list.stdout b/cmdtests/list.stdout
index 9e93fb104e15..386895e72e7c 100644
--- a/cmdtests/list.stdout
+++ b/cmdtests/list.stdout
@@ -25,8 +25,9 @@ a
 
 fb409caeb2ec foo: test 1
 
-Update state in patchwork? [y/N] y
-y
+Accept/request Changes/Reject/Show mail/Edit mail/aBort? a
+a
+1 patches accepted, 0 skipped
 ============================================================
 Content-Type: text/plain; charset="us-ascii"
 MIME-Version: 1.0
@@ -54,6 +55,7 @@ Envelope To: ['Dino Dinosaurus <dino@example.com>']
 Send/Edit/Abort? s
 s
 smtpd: test@example.com -> dino@example.com
+Email sent
 test-branch@data > quit
 mails: ['0']
 smtpddir/0:
diff --git a/pwcli b/pwcli
index 83951b49c064..770bf73a16bf 100755
--- a/pwcli
+++ b/pwcli
@@ -949,20 +949,7 @@ class PWCLI():
 
          self.output('')
 
-      while True:
-         answer = self.input('Update state in patchwork? [y/N] ')
-         answer = answer.lower()
-
-         if answer == 'y':
-            for patch in applied:
-               patch.set_state_name('Accepted')
-
-            break
-
-         if answer == 'n' or len(answer) == 0:
-            break
-
-      # send "applied" email
+      # create the "Thanks, applied" email
       patch = applied[0]
       reply = patch.get_reply_msg(self.fullname, self.email)
 
@@ -993,7 +980,64 @@ class PWCLI():
 
       reply.set_payload(payload)
 
-      self.send_email(reply)
+      while True:
+
+         while True:
+            choices = 'Accept/request Changes/Reject/Show mail/Edit mail/aBort? '
+            answer = self.input(choices)
+            answer = answer.lower()
+
+            valid = ['a', 'c', 'r', 's', 'e', 'b']
+
+            if answer in valid:
+               break
+
+            self.output('Unknown choise \'%s\', valid choises are: %s' % (answer,
+                                                                       ', '.join(valid)))
+
+         if answer == 'a':
+            # Accept
+            for patch in applied:
+               patch.set_state_name('Accepted')
+
+            # FIXME: what to do with skipped patches?
+            self.output('%d patches accepted, %d skipped' % (len(applied),
+                                                             len(skipped)))
+
+            self.send_email(reply)
+
+            self.output('Email sent')
+
+            break
+
+         if answer == 'c':
+            # request Changes
+
+            # sets all patches to 'Changes Requested' and creates an
+            # email requesting changes (send_email(edit=True))
+            self.output('FIXME: implement')
+
+         if answer == 'r':
+            # Reject
+            # sets all patches to 'Rejected' and creates an
+            # email stating the reason (send_email(edit=True))
+            self.output('FIXME: implement')
+
+         if answer == 's':
+            # Show mail
+            self.output(reply.as_string())
+
+         if answer == 'e':
+            # Edit mail
+            buf = self.edit_file(reply.as_string())
+
+            # FIXME: check if the mail is malformed
+            reply = email.message_from_string(buf)
+
+         if answer == 'b':
+            # aBort
+            self.output('Aborted commit command')
+            return
 
    def cmd_show(self, args):
       logger.debug('cmd_show(args=%s)' % repr(args))
-- 
1.7.9.5

